#include "precompile.h"

#include <math.h>
#include <float.h>

#include "buff/beatback.h"
#include "creature.h"

#include "mt/Buff.h"

void BeatBackBuff::Activate()
{
    if (caster_.Get()) {
        #if 1
        if (std::abs(caster_.Get()->GetAttackDir().x) > FLT_EPSILON ||
            std::abs(caster_.Get()->GetAttackDir().y) > FLT_EPSILON) {
            float distance = meta->GetBuffParam1(this);
            if (std::abs(distance) > 0) {
                glm::vec3 old_move_dir = owner->GetMoveDir();
                owner->SetMoveDir(caster_.Get()->GetAttackDir());
                owner->ForwardMove(distance);
                owner->SetMoveDir(old_move_dir);
            }
        }
        #else
        if (std::abs(caster_.Get()->context_dir.x) > FLT_EPSILON ||
            std::abs(caster_.Get()->context_dir.x) > FLT_EPSILON) {
            if (std::abs(meta->_int_buff_param1) > 0) {
                glm::vec3 old_move_dir = owner->GetMoveDir();
                owner->SetMoveDir(caster_.Get()->context_dir);
                owner->ForwardMove(meta->_buff_param1);
                owner->SetMoveDir(old_move_dir);
            }
        }
        #endif
    }
}

void BeatBackBuff::Deactivate()
{

}
