#include "precompile.h"

#include "buff/jump.h"

#include "creature.h"
#include "human.h"
#include "room.h"
#include "trigger.h"

void JumpBuff::Activate()
{
    owner->GetTrigger()->StartJump(owner);
}

void JumpBuff::Deactivate()
{
    //跳伞结束
    CreatureWeakPtr c = owner->GetWeakPtrRef();
    owner->room->xtimer.SetTimeoutEx
        (1,
         [c] (int event, const a8::Args* args) mutable
         {
             if (a8::TIMER_EXEC_EVENT == event) {
                 if (c.Get()) {
                     c.Get()->OnLand();
                     c.Get()->GetTrigger()->EndJump(c.Get());
                 }
             }
         },
         &owner->xtimer_attacher);
}
