#include "precompile.h"

#include "buff/passenger.h"

#include "creature.h"

void PassengerBuff::Activate()
{
    hold_curr_weapon_idx_ = caster_.Get()->GetCurrWeapon()->weapon_idx;
    CalcPassengerShotOffset();
    caster_.Get()->MarkSyncActivePlayer(__FILE__, __LINE__, __func__);
    caster_.Get()->SyncAroundPlayers(__FILE__, __LINE__, __func__);
}

void PassengerBuff::Deactivate()
{
    RecoverHoldWeapons();
    caster_.Get()->shoot_offset = GlmHelper::ZERO;
}
