#include "precompile.h"

#include <math.h>
#include <float.h>

#include "buff/pull_to_walkable.h"

#include "creature.h"
#include "room.h"
#include "mapinstance.h"
#include "app.h"

void PullToWalkableBuff::Activate()
{
    glm::vec3 center = owner->GetPos().ToGlmVec3();
    owner->room->map_instance->Scale(center);
    glm::vec3 point;
    bool ok = owner->room->map_instance->FindNearestPoint(center, 2, point);
    if (!ok) {
        abort();
    }
    owner->room->map_instance->UnScale(point);
    App::Instance()->verify_set_pos = 1;
    owner->GetMutablePos().FromGlmVec3(point);
    App::Instance()->verify_set_pos = 0;
}

void PullToWalkableBuff::Deactivate()
{

}
