#include "precompile.h"

#include "buff/rescuer.h"

#include "creature.h"
#include "trigger.h"
#include "room.h"
#include "human.h"

void RescuerBuff::Activate()
{
    Human* target = owner->room->GetHumanByUniId(owner->AsHuman()->GetActionTargetId());
    if (target) {
        owner->GetTrigger()->StartRescue(target);
    }
}

void RescuerBuff::Deactivate()
{
    Human* target = owner->room->GetHumanByUniId(owner->AsHuman()->GetActionTargetId());
    if (target) {
        owner->GetTrigger()->EndRescue(target);
    }
}
