#include "precompile.h"

#include "buff/use_skill.h"

#include "creature.h"
#include "skill.h"

#include "mt/Buff.h"
#include "mt/Skill.h"

void UseSkillBuff::Activate()
{
    Skill* skill = owner->GetSkill(meta->_int_buff_param1);
    if (skill) {
        ++skill->force_use_times;
        Position target_pos = owner->GetPos();
        owner->DoSkill(
                       skill->GetBaseSkillMeta()->skill_id(),
                       owner->GetUniId(),
                       owner->GetAttackDir(),
                       0
                       );
    }
}

void UseSkillBuff::Deactivate()
{

}
