#pragma once

#include "microtask.h"

class Room;
class Player;
class FragMiTask : public MicroTask
{
 public:
    Position bomb_pos;
    CreatureWeakPtr sender;
    CreatureWeakPtr follow_target;
    CreatureWeakPtr force_target;
    const mt::Equip* gun_meta = nullptr;
    const mt::Equip* meta = nullptr;
    float explosion_range = 1;
    float atk = 0;
    int bullet_uniid = 0;

    void Done();
    float GetAtk() { return atk; }
};
