#pragma once

struct GasData
{
    glm::vec2 pos_old;
    glm::vec2 pos_old_bk;
    glm::vec2 pre_pos_old;
    glm::vec2 pos_new;
    float rad_old = 0.0f;
    float rad_new = 0.0f;
    float gas_progress = 0.0f;
    long long gas_start_frameno = 0;
    const mt::SafeArea* old_area_meta = nullptr;
    const mt::SafeArea* new_area_meta = nullptr;
    const mt::SafeAreaPos* pos_list = nullptr;
    bool is_last_gas = false;
    int gas_count = 0;

    GasMode_e GetGasMode() const { return gas_mode_; };
    void SetGasMode(GasMode_e gas_mode);

private:
    GasMode_e gas_mode_ = GasInactive;

};
