#pragma once

#include "mt/macro.h"
#include "mtb/AI.h"

namespace mt
{

    DECLARE_ID_TABLE(AI, mtb::AI,
                     "ai@ai.json",
                     "id")
    public:

        void Init1();
        void Init2();
        int GetMoveIdleTime() const;
        int GetMoveTime() const;

        float _param1 = 0.0f;
        float _param2 = 0.0f;
        float _param3 = 0.0f;
        float _param4 = 0.0f;
        float _param5 = 0.0f;
        int _int_param1 = 0;
        int _int_param2 = 0;
        int _int_param3 = 0;
        int _int_param4 = 0;
        int _int_param5 = 0;
        std::vector<int> _int_list_param1;
        std::vector<int> _int_list_param2;
        std::vector<int> _int_list_param3;
        std::vector<int> _int_list_param4;
        std::vector<int> _int_list_param5;
        std::set<int> _int_set_param1;
        std::set<int> _int_set_param2;
        std::set<int> _int_set_param3;
        std::set<int> _int_set_param4;
        std::set<int> _int_set_param5;

        long long _bits_param2 = 0;

    private:
        std::tuple<int, int> _random_move_idle_time;
        std::tuple<int, int> _random_move_time;
    };

}
