#pragma once

#include "mt/macro.h"
#include "mtb/AirDrop.h"

namespace mt
{

    DECLARE_ID_TABLE(AirDrop, mtb::AirDrop,
                     "airdrop@airdrop.json",
                     "id")
    public:

        bool HasDrop() const { return !_drop.empty();};

        void Init1();
        int RandDrop() const;

    private:
        std::vector<std::tuple<int, int>> _drop;
    };

}
