#include "precompile.h"

#include "mt/AirRaid.h"

IMPL_TABLE(mt::AirRaid)

namespace mt
{
    void AirRaid::Init1()
    {
        {
            std::vector<std::string> strings;
            a8::Split(bomb_id(), strings, '|');
            for (auto& str : strings) {
                _bomb_ids.push_back(a8::XValue(str));
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(raid_wave(), strings, '|');
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                _raid_waves.push_back(std::make_tuple(
                                                     a8::XValue(strings2[0]).GetInt(),
                                                     a8::XValue(strings2[1]).GetInt()
                                                     )
                                     );
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(bombling_time(), strings, ':');
            if (strings.size() == 0) {
                _bombing_time = std::make_tuple(0, 0);
            } else if (strings.size() == 2) {
                _bombing_time = std::make_tuple(a8::XValue(strings[0]).GetInt(),
                                                 a8::XValue(strings[1]).GetInt());
            } else {
                abort();
            }
        }
    }

}
