#include "precompile.h"

#include <math.h>

#include "mt/GunQuality.h"

IMPL_TABLE(mt::GunQuality)

namespace mt
{

    long long GunQuality::GetPvpCegUpLimit() const
    {
        double sys_param = 0;
        long long up_limit = round
            (
             (
              0.0111*pow(quality(),3) -
              0.25974*pow(quality(),2) +
              3.29292*quality() +
              1.3389
              ) +
             (
              0.0074*pow(lucky(), 3) -
              0.59396*pow(lucky(), 2) +
              16.7708*lucky() -
              153.964
              )
             ) + sys_param;
        return up_limit;
    }

}
