#pragma once

#include "mt/macro.h"
#include "mtb/KillReward.h"

namespace mt
{

    DECLARE_ID_TABLE(KillReward, mtb::KillReward,
                     "killReward@killReward.json",
                     "kill_num")
    public:

      void Init1();
      static float GetKillRewardParam(int kill_num);

    private:

      static std::map<int, const mt::KillReward*> kill_hash_;

    };

}
