#pragma once

#include "mt/macro.h"
#include "mtb/MapMode.h"

namespace mt
{
    const int kPvpRankMode = 401;
    const int kTreasureBoxMode = 501;

    DECLARE_ID_TABLE(MapMode, mtb::MapMode,
                     "mapMode@mapMode.json",
                     "id")
    public:

      void Init1();

      bool IsOpen() const;

    private:
      std::map<int, int> _map_list;
    };

}
