#include "precompile.h"

#include "mt/MergeItem.h"

IMPL_TABLE(mt::MergeItem)

namespace mt
{

    void MergeItem::Init1()
    {
        {
            std::set<int> buffs;
            {
                std::vector<std::string> strings;
                a8::Split(pickup3(), strings, '|');
                for (auto& str : strings) {
                    if (!str.empty()) {
                        if (str.at(0) == '-') {
                            buffs.erase(-a8::XValue(str).GetInt());
                        } else {
                            buffs.insert(a8::XValue(str).GetInt());
                        }
                    }
                }
                for (int i = 1; i <= 3; ++i) {
                    gun_num_buff_hash_[i] = buffs;
                }
            }
            {
                std::vector<std::string> strings;
                a8::Split(pickup6(), strings, '|');
                for (auto& str : strings) {
                    if (!str.empty()) {
                        if (str.at(0) == '-') {
                            buffs.erase(-a8::XValue(str).GetInt());
                        } else {
                            buffs.insert(a8::XValue(str).GetInt());
                        }
                    }
                }
                for (int i = 3; i <= 6; ++i) {
                    gun_num_buff_hash_[i] = buffs;
                }
            }
            {
                std::vector<std::string> strings;
                a8::Split(pickup9(), strings, '|');
                for (auto& str : strings) {
                    if (!str.empty()) {
                        if (str.at(0) == '-') {
                            buffs.erase(-a8::XValue(str).GetInt());
                        } else {
                            buffs.insert(a8::XValue(str).GetInt());
                        }
                    }
                }
                for (int i = 6; i <= 9; ++i) {
                    gun_num_buff_hash_[i] = buffs;
                }
            }
        }
    }

    std::set<int>* MergeItem::GetBuffs(int num)
    {
        auto itr = gun_num_buff_hash_.find(num);
        return itr != gun_num_buff_hash_.end() ? &itr->second : nullptr;;
    }

}
