#pragma once

#include "mt/macro.h"
#include "mtb/MobaRoom.h"

namespace mt
{

    DECLARE_ID_TABLE(MobaRoom, mtb::MobaRoom,
                     "mobaRoom@mobaRoom.json",
                     "map_id")
    public:

        void Init1();
        void Init2();

        std::vector<std::tuple<glm::vec3, float>> moba_towers;
        std::vector<std::tuple<glm::vec3, float, int>> moba_batterys;
        int GetMonsterReviveTime(int hero_id) const;
        int GetMonsterLootLifeTime(int hero_id) const;

    private:
        std::map<int, std::tuple<int, int>> monster_revive_;
    };

}
