#pragma once

#include <bitset>

namespace mtb
{

  class AirDrop
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int time() const { return time_; };
    int appear_time() const { return appear_time_; };
    const std::string drop_id() const { return drop_id_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_time() const { return __flags__.test(1);};
    bool has_appear_time() const { return __flags__.test(2);};
    bool has_drop_id() const { return __flags__.test(3);};

  protected:

    int id_ = 0;
    int time_ = 0;
    int appear_time_ = 0;
    std::string drop_id_;

public:
    std::bitset<4> __flags__;
  };

};
