#pragma once

#include <bitset>

namespace mtb
{

  class BattleWeaponAttribute
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int weapon() const { return weapon_; };
    int level() const { return level_; };
    const std::string levelAttribute() const { return levelAttribute_; };
    const std::string cost() const { return cost_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_weapon() const { return __flags__.test(1);};
    bool has_level() const { return __flags__.test(2);};
    bool has_levelAttribute() const { return __flags__.test(3);};
    bool has_cost() const { return __flags__.test(4);};

  protected:

    int id_ = 0;
    int weapon_ = 0;
    int level_ = 0;
    std::string levelAttribute_;
    std::string cost_;

public:
    std::bitset<5> __flags__;
  };

};
