#pragma once

#include <bitset>

namespace mtb
{

  class Distribution
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    const std::string point() const { return point_; };
    const std::string value() const { return value_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_point() const { return __flags__.test(1);};
    bool has_value() const { return __flags__.test(2);};

  protected:

    int id_ = 0;
    std::string point_;
    std::string value_;

public:
    std::bitset<3> __flags__;
  };

};
