#pragma once

#include <bitset>

namespace mtb
{

  class MergeItem
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int equip_id() const { return equip_id_; };
    int skill_id() const { return skill_id_; };
    const std::string pickup3() const { return pickup3_; };
    const std::string pickup6() const { return pickup6_; };
    const std::string pickup9() const { return pickup9_; };

    bool has_equip_id() const { return __flags__.test(0);};
    bool has_skill_id() const { return __flags__.test(1);};
    bool has_pickup3() const { return __flags__.test(2);};
    bool has_pickup6() const { return __flags__.test(3);};
    bool has_pickup9() const { return __flags__.test(4);};

  protected:

    int equip_id_ = 0;
    int skill_id_ = 0;
    std::string pickup3_;
    std::string pickup6_;
    std::string pickup9_;

public:
    std::bitset<5> __flags__;
  };

};
