#pragma once

#include <bitset>

namespace mtb
{

  class NpcStandard
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int quality() const { return quality_; };
    int hp() const { return hp_; };
    int damage() const { return damage_; };
    int defence() const { return defence_; };
    int hero_id() const { return hero_id_; };
    int level() const { return level_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_quality() const { return __flags__.test(1);};
    bool has_hp() const { return __flags__.test(2);};
    bool has_damage() const { return __flags__.test(3);};
    bool has_defence() const { return __flags__.test(4);};
    bool has_hero_id() const { return __flags__.test(5);};
    bool has_level() const { return __flags__.test(6);};

  protected:

    int id_ = 0;
    int quality_ = 0;
    int hp_ = 0;
    int damage_ = 0;
    int defence_ = 0;
    int hero_id_ = 0;
    int level_ = 0;

public:
    std::bitset<7> __flags__;
  };

};
