#pragma once

#include <bitset>

namespace mtb
{

  class PveGeminiContent
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int mode_id() const { return mode_id_; };
    int round() const { return round_; };
    const std::string spawn_point() const { return spawn_point_; };
    const std::string enemy_id() const { return enemy_id_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_mode_id() const { return __flags__.test(1);};
    bool has_round() const { return __flags__.test(2);};
    bool has_spawn_point() const { return __flags__.test(3);};
    bool has_enemy_id() const { return __flags__.test(4);};

  protected:

    int id_ = 0;
    int mode_id_ = 0;
    int round_ = 0;
    std::string spawn_point_;
    std::string enemy_id_;

public:
    std::bitset<5> __flags__;
  };

};
