#pragma once

#include <bitset>

namespace mtb
{

  class Text
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    const std::string textid() const { return textid_; };
    const std::string text() const { return text_; };

    bool has_textid() const { return __flags__.test(0);};
    bool has_text() const { return __flags__.test(1);};

  protected:

    std::string textid_;
    std::string text_;

public:
    std::bitset<2> __flags__;
  };

};
