#pragma once

#include "base_agent.h"

class Room;
class Team;
class TeamAgent : public BaseAgent
{
public:
    TeamAgent();

    virtual ~TeamAgent() override;

    BEHAVIAC_DECLARE_AGENTTYPE(TeamAgent, BaseAgent)

    int GetMemberNum();
    int GetPlayerNum();
    int GetAlivePlayerNum();

    void SetOwner(Creature* owner);
    Room* GetRoom();

private:
    Creature* owner_ = nullptr;
};
