#include "precompile.h"

#include "btevent.h"
#include "base_agent.h"

std::shared_ptr<BtEvent> BtEvent::Create(int event_id,
                                         a8::Args event_params,
                                         std::function<bool()> has_event_cb
                                         )
{
    return std::make_shared<BtEvent>(
                                     event_id,
                                     event_params,
                                     has_event_cb
                                     );
}

void BtEvent::FireEvent(BaseAgent* agent)
{
}
