#pragma once

#include "human.h"

class AndroidAgent;
class Android : public Human
{
 public:
    const mt::Robot* robot_meta = nullptr;

    virtual ~Android() override;
    virtual void Initialize() override;
    virtual void Update(int delta_time) override;
    void GiveEquip();

protected:
    Android();

private:
    AndroidAgent* agent_ = nullptr;

    void InternalUpdate(int delta_time);
    void RandSkin();
    void UpdateMoving();

    friend class PBUtils;
    friend class EntityFactory;
};
