#pragma once

#include "buff.h"
#include "trigger.h"

A8_DECLARE_CLASS_ENUM(CondAddBuff_e, int,
                      kBulletHit = 11,
                      kBulletKill = 12,
                      kBulletEnd = 13,

                      kDisengageBattle = 21,
                      kLimitTimeKillTarget = 22,
                      kReload = 23,
                      kShot = 24,
                      kFlyDestory = 25,
                      kEnd
                      );

class CondAddBuff : public Buff
{
 public:

    virtual void Activate() override;
    virtual void Deactivate() override;

 private:

    void ProcBulletHit();
    void ProcBulletKill();
    void ProcBulletEnd();
    void ProcDisengageBattle();
    void ProcLimitTimeKillTarget();
    void ProcReload();
    void ProcShot();
    void ProcFlyDestory();

};
