#pragma once

#include "buff.h"

class HideBuff : public Buff
{
 public:

    virtual void Activate() override;
    virtual void Deactivate() override;

 private:
    void AddInRangeObject(Creature* target);
    void Check();

 private:
    int step_ = 1;
    std::map<int, std::tuple<CreatureWeakPtr, long long, int, int>> alert_buff_hash_;

    float alert_range = 0.0f;
    float alert_time = 0.0f;

};
