#include "precompile.h"

#include "loot.h"
#include "room.h"
#include "entity.h"
#include "app.h"
#include "typeconvert.h"
#include "perfmonitor.h"
#include "pbutils.h"

Loot::Loot():RoomEntity()
{
    ++PerfMonitor::Instance()->entity_num[ET_Loot];
}

Loot::~Loot()
{
    SetDestorying();
    --PerfMonitor::Instance()->entity_num[ET_Loot];
}

void Loot::Initialize()
{
    RoomEntity::Initialize();
}
