#include "precompile.h"

#include "mt/KillPoint.h"

IMPL_TABLE(mt::KillPoint)
std::map<int, const mt::KillPoint*> mt::KillPoint::kill_hash_;

namespace mt
{

    void KillPoint::Init1()
    {
        kill_hash_[kill_num()] = this;
    }

    int KillPoint::GetKillPointParam1(int kill_num)
    {
        auto itr = kill_hash_.find(kill_num);
        return itr != kill_hash_.end() ? itr->second->parameter() : 0;
    }

    int KillPoint::GetKillPointParam2(int kill_num)
    {
        auto itr = kill_hash_.find(kill_num);
        return itr != kill_hash_.end() ? itr->second->parameter2() : 0;
    }

}
