#pragma once

#include "mt/macro.h"
#include "mtb/KillPoint.h"

namespace mt
{

    DECLARE_ID_TABLE(KillPoint, mtb::KillPoint,
                     "killPoint@killPoint.json",
                     "kill_num")
    public:

        void Init1();
        static int GetKillPointParam1(int kill_num);
        static int GetKillPointParam2(int kill_num);

    private:

        static std::map<int, const mt::KillPoint*> kill_hash_;
    };

}
