#pragma once

#include "mt/macro.h"
#include "mtb/RankPoint.h"

namespace mt
{

    DECLARE_ID_TABLE(RankPoint, mtb::RankPoint,
                     "rankPoint@rankPoint.json",
                     "rank")
    public:

       void Init1();
       static int GetRankPointParam1(int rank);
       static int GetRankPointParam2(int rank);
       static int GetRankPointParam3(int rank);

    private:
       static std::map<int, const mt::RankPoint*> rank_hash_;

    };

}
