#pragma once

#include "mt/macro.h"
#include "mtb/SafeAreaPos.h"

namespace mt
{

    DECLARE_AUTO_ID_TABLE(SafeAreaPos, mtb::SafeAreaPos,
                          "safearea_pos@safearea_pos.json"
                          )
    public:

        void Init1();
        void Init2();

        std::vector<glm::vec3> _poses;

        static const SafeAreaPos* RandSafeAreaPos(int area_id);
        static std::vector<mt::SafeAreaPos*>* GetSafeAreaPosList(int area_id);

    private:
        static std::map<int, std::vector<mt::SafeAreaPos*>> area_hash_;
    };

}
