#pragma once

#include "mt/macro.h"
#include "mtb/Text.h"

#define TEXT(textid, def_text) mt::Text::GetText(textid, def_text)

namespace mt
{

    DECLARE_NAME_TABLE(Text, mtb::Text,
                     "text@text.json",
                     "textid")
    public:

      void Init1();
      static std::string GetText(const std::string& textid, const std::string& def_text = "");
      static std::vector<std::tuple<int, std::string>>* GetTextElements(const std::string& textid);

    private:
      static std::map<std::string, std::vector<std::tuple<int, std::string>>> text_element_hash_;
    };

}
