#pragma once

#include <bitset>

namespace mtb
{

  class Condition
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    const std::string param1() const { return param1_; };
    const std::string param2() const { return param2_; };
    const std::string param3() const { return param3_; };
    const std::string param4() const { return param4_; };
    const std::string param5() const { return param5_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_param1() const { return __flags__.test(1);};
    bool has_param2() const { return __flags__.test(2);};
    bool has_param3() const { return __flags__.test(3);};
    bool has_param4() const { return __flags__.test(4);};
    bool has_param5() const { return __flags__.test(5);};

  protected:

    int id_ = 0;
    std::string param1_;
    std::string param2_;
    std::string param3_;
    std::string param4_;
    std::string param5_;

public:
    std::bitset<6> __flags__;
  };

};
