#pragma once

#include <bitset>

namespace mtb
{

  class Drop
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int drop_id() const { return drop_id_; };
    const std::string item_id() const { return item_id_; };
    const std::string num() const { return num_; };
    const std::string weight() const { return weight_; };
    int type() const { return type_; };

    bool has_drop_id() const { return __flags__.test(0);};
    bool has_item_id() const { return __flags__.test(1);};
    bool has_num() const { return __flags__.test(2);};
    bool has_weight() const { return __flags__.test(3);};
    bool has_type() const { return __flags__.test(4);};

  protected:

    int drop_id_ = 0;
    std::string item_id_;
    std::string num_;
    std::string weight_;
    int type_ = 0;

public:
    std::bitset<5> __flags__;
  };

};
