#pragma once

#include <bitset>

namespace mtb
{

  class MapThingGroup
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int mtGroupId() const { return mtGroupId_; };
    const std::string rule() const { return rule_; };
    const std::string mapThings() const { return mapThings_; };
    const std::string heroes() const { return heroes_; };

    bool has_mtGroupId() const { return __flags__.test(0);};
    bool has_rule() const { return __flags__.test(1);};
    bool has_mapThings() const { return __flags__.test(2);};
    bool has_heroes() const { return __flags__.test(3);};

  protected:

    int mtGroupId_ = 0;
    std::string rule_;
    std::string mapThings_;
    std::string heroes_;

public:
    std::bitset<4> __flags__;
  };

};
