#pragma once

#include <bitset>

namespace mtb
{

  class Parameter
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    const std::string param_name() const { return param_name_; };
    const std::string param_value() const { return param_value_; };

    bool has_param_name() const { return __flags__.test(0);};
    bool has_param_value() const { return __flags__.test(1);};

  protected:

    std::string param_name_;
    std::string param_value_;

public:
    std::bitset<2> __flags__;
  };

};
