#pragma once

#include <bitset>

namespace mtb
{

  class RankReward
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int rank() const { return rank_; };
    float parameter() const { return parameter_; };
    int drop() const { return drop_; };

    bool has_rank() const { return __flags__.test(0);};
    bool has_parameter() const { return __flags__.test(1);};
    bool has_drop() const { return __flags__.test(2);};

  protected:

    int rank_ = 0;
    float parameter_ = 0.0f;
    int drop_ = 0;

public:
    std::bitset<3> __flags__;
  };

};
