#pragma once

namespace cs
{
    class MFActivePlayerData;
    class MFPlayerFull;
    class MFAttrAddition;
    class MFWeapon;
    class MFBuff;
    class MFSkill;
    class MFSkin;
    class MFObjectPart;
    class MFObjectFull;
    class MFGasData;
    class MFPlayerStats;
    class MFCharacterImage;
    class MFTeamData;
    class SMRollMsg;
    class SMPvePassWave;
    class SMGameOver;
}

class Ability;
class Human;
class Weapon;
class Creature;
class Buff;
class Car;
class Hero;
class Loot;
class Obstacle;
class Skill;
class Skin;
struct KillInfo;
struct RollMsgHintInfo;
class PBUtils
{
 public:

    static void Ability_FillMFAttrAdditionList(Ability* self, Human* hum, cs::MFActivePlayerData* player_data);
    static void Ability_FillMFAttrAdditionList(Ability* self, Human* hum, cs::MFPlayerFull* full_data);

    static void Human_SendSMPvePassWave(Human* self, int new_wave, int pve_max_wave, int wait_time);

 private:
    static void _Ability_FillMFAttrAdditionList
        (Ability* self,
         Human* hum,
         std::function<cs::MFAttrAddition* ()> add_func
         );

};
