#pragma once

class Hero;
struct PveData
{
    int max_wave = 0;
    int mon_num = 0;
    int boss_state = 0;

    int refreshed_mon = 0;
    int killed_num = 0;

    bool pve_kill_boss = false;

    int GetWave() { return wave_; };
    void SetWave(int wave) { wave_ = wave; };
    void AddDamageInfo(int sender_id, int receiver_id, float dmg);
    void OnBeKill(Hero* hero);
    int GetPassedWave();


private:
    void FlyDoor(Room* room, glm::vec3& point, int radius);

private:
    int wave_ = 0;

    std::map<int, std::map<int, float>> damage_hash_;

};
