#include "precompile.h"

#include "team_agent.h"

#include "team.h"
#include "creature.h"

TeamAgent::TeamAgent():BaseAgent()
{

}

TeamAgent::~TeamAgent()
{
}

int TeamAgent::GetMemberNum()
{
    return owner_->GetTeam()->GetMemberNum();
}

int TeamAgent::GetPlayerNum()
{
    return owner_->GetTeam()->GetPlayerNum();
}

int TeamAgent::GetAlivePlayerNum()
{
    return owner_->GetTeam()->GetAlivePlayerNum();
}

void TeamAgent::SetOwner(Creature* owner)
{
    owner_ = owner;
}

Room* TeamAgent::GetRoom()
{
    return owner_->GetTeam()->room;
}
