#pragma once

#include <a8/singleton.h>
#include <f8/app.h>

class App : public f8::UserApp, public a8::Singleton<App>
{
private:
    App() {};
    friend class a8::Singleton<App>;

public:

    virtual const std::string GetPkgName() override;
    virtual void Init() override;
    virtual void UnInit() override;
    virtual void Update(int delta_time) override;
    virtual bool HasTask() override;
    virtual void DispatchSocketMsg(f8::MsgHdr* hdr) override;

};
