#pragma once

#define PERF 1

#include <a8/singleton.h>

class Perf : public a8::Singleton<Perf>
{
private:
    Perf() {};
    friend class a8::Singleton<Perf>;
 public:
    void Init();
    void UnInit();

    long long login_ok_times = 0;
    long long login_fail_times = 0;
    long long enter_ok_times = 0;
    long long enter_fail_times = 0;
    long long connect_ok_times = 0;
    long long connect_fail_times = 0;
    long long join_ok_times = 0;
    long long chg_dir_times = 0;
    long long send_move_times = 0;
    long long update_times = 0;

    void Output();

};
